# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc列表查询条件验证_可使用商品返利清单,2271,2271-45,sit,bs
主数据平台:后台运营系统可使用商品返利清单查询接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
import requests
import random
import json

module = "cmdc_rebate"

# 第一步登录后台运营平台获取cmdc_access_token
# 获取登录所需账号密码
username = commonFuc().get_business_data(module, "username1")
password = commonFuc().get_business_data(module, "password1")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers", cmdc_access_token)

# 第二步获取获取可使用商品返利清单
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url35")
request_body = commonFuc().get_business_data(module, "payload35")
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)

# 生成一个随机数字
product_random = random.randint(0, len(result["data"]["list"]) - 1)
# 获取获取可使用商品返利清单信息
product_name = result["data"]["list"][product_random]["productName"]
product_code = result["data"]["list"][product_random]["productCode"]
specifications = result["data"]["list"][product_random]["specifications"]
manufacturer = result["data"]["list"][product_random]["manufacturer"]

# 第三步进行可使用商品返利清单查询
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url36")
request_body = commonFuc().get_business_data(module, "payload36", product_name, product_code, specifications,
                                             manufacturer)

"""
 场景: 列表查询条件验证_可使用商品返利清单
 用例名称：列表查询条件验证_可使用商品返利清单
 输出：{"productCode":"%s"}
"""

# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)
# print(result)
# 获取查询结果中可使用商品返利清单信息
result = {"productCode": result["data"]["list"][0]["productCode"]}

# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict36", product_code)
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)
