# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc列表查询条件验证_返利使用明细,2271,2271-2,sit,bs
主数据平台:后台运营系统返利使用明细查询接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
import requests
import datetime
import random
import json

module = "cmdc_rebate"

# 第一步登录后台运营平台获取cmdc_access_token
# 获取登录所需账号密码
username = commonFuc().get_business_data(module, "username1")
password = commonFuc().get_business_data(module, "password1")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers", cmdc_access_token)

# 第二步获取返利使用明细
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url1")
request_body = commonFuc().get_business_data(module, "payload1")
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)


# 此函数用于当x为none时，进行空字符串替换
def func(x):
    if x is None:
        x = ""
        return x
    else:
        return x


# 生成一个随机数字，用于后续随机选择某一条返利使用明细
rebate_random = random.randint(0, len(result["data"]["list"]) - 1)
# 获取返利使用明细列表中某一条明细信息
customer_code = result["data"]["list"][rebate_random]["customerCode"]
customer_name = result["data"]["list"][rebate_random]["customerName"]
relevance_name = result["data"]["list"][rebate_random]["relevanceName"]
transaction_type = result["data"]["list"][rebate_random]["transactionType"]
rebate_id = result["data"]["list"][rebate_random]["rebateId"]
rebate_name = result["data"]["list"][rebate_random]["rebateName"]
list_order_status = func(result["data"]["list"][rebate_random]["orderStatus"])
demand_code = func(result["data"]["list"][rebate_random]["demandCode"])
start_time = result["data"]["list"][rebate_random]["createTimeStr"]
# 获取当前时间作为交易时间截止时间
end_time = datetime.datetime.now().strftime('%Y-%m-%d %H:%M:%S')

# 第三步进行条件查询验证
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url2")
request_body = commonFuc().get_business_data(module, "payload2", customer_code, customer_name, relevance_name,
                                             transaction_type,
                                             rebate_id, rebate_name, list_order_status, demand_code, start_time,
                                             end_time)

"""
 场景: 验证返利使用明细列表查询条件是否可以正常使用
 用例名称：列表查询条件验证_返利使用明细
 输出：{"customerCode":"%s"}
"""

# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)
print(result)
# 获取查询结果中使用明细对应的客户编号
result = {"customerCode": result["data"]["list"][0]["customerCode"]}
# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict2", customer_code)
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)
